import 'package:firebase_auth/firebase_auth.dart';
import 'package:wowit/methods.dart';
import 'package:wowit/models/base_model.dart';

class BaseUserModel extends BaseModel {
  BaseUserModel([Map<String, Object?>? data]) : super(data ?? {});

  bool get isLoggedIn => id > 0;

  String get notifyTokenId => Methods.getString(data, 'notifyTokenId');
  set notifyTokenId(String value) => data['notifyTokenId'] = value;

  void init(Map<String, Object?> data) {
    this.data.clear();
    this.data.addAll(data);
  }

  void merge(dynamic object) {
    if (object == null) return;
    if (object is BaseUserModel) {
      for (var item in object.data.entries) {
        data.update(item.key, (_) => item.value, ifAbsent: () => item.value);
      }
    }
    if (object is User) {
      data.update(
        'phone',
        (_) => object.phoneNumber,
        ifAbsent: () => object.phoneNumber,
      );
      data.update(
        'uidPhone',
        (_) => object.uid,
        ifAbsent: () => object.uid,
      );
    }
  }

  void clear() {
    data.clear();
  }
}
